
%global meadversion 2.0.2
%global namedversion 2.0.2.redhat-3
%global meadalpha .redhat_3
%global meadrel .1
%global serial 8

# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%global short_name xmlschema


%define maven_version 2.0.2.redhat-3

Name:           ws-commons-XmlSchema
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        XmlSchema Object Model
License:        ASL 2.0
URL:            http://ws.apache.org/commons/XmlSchema/
Group:          Development/Java

%if %with mead
Source100: xmlschema-2.0.2.redhat-3-scm-sources.zip
Source102: xmlschema-2.0.2.redhat-3.pom
Source103: xmlschema-core-2.0.2.redhat-3.jar
Source104: xmlschema-core-2.0.2.redhat-3-sources.jar
Source105: xmlschema-core-2.0.2.redhat-3.pom
Source106: xmlschema-core-2.0.2.redhat-3.zip
Source107: xmlschema-core-2.0.2.redhat-3-javadoc.jar
%endif


BuildRequires:  java-devel
%if %without mead
# svn export http://svn.apache.org/repos/asf/webservices/xmlschema/tags/xmlschema-2.0.2/
# Exported revision 1333739.
# tar zcf ws-commons-XmlSchema-2.0.2-src.tar.gz xmlschema-2.0.2

Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://www.w3.org/XML/2004/xml-schema-test-suite/xmlschema2002-01-16/xsts-2002-01-16.tar.gz


#Patch0:         %{name}-pom.patch
#Patch1:         %{name}-core-pom.patch

Patch2:         %{name}-%{version}-pom-vman.patch

BuildRequires:  jpackage-utils
BuildRequires:  java-devel
BuildRequires:  ant
BuildRequires:  ant-nodeps
BuildRequires:  ant-trax
BuildRequires:  junit4 >= 0:4.8
BuildRequires:  xmlunit
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven2 >= 2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-checkstyle-plugin
BuildRequires:  maven-pmd-plugin
BuildRequires:  plexus-velocity
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  jboss-parent
BuildRequires:  objectweb-asm
#BuildRequires:  ws-commons-java5
%endif

Requires:  jpackage-utils
#Requires:  ws-commons-java5
Requires(post):    jpackage-utils
Requires(postun):  jpackage-utils

BuildArch:      noarch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
XMLSchema is a lightweight schema object model that can be 
used to manipulate and generate XML schema representations. 
It has very few external dependancies and can be easily 
integrated into an existing project.

%if %without mead
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n %{short_name}-%{version}
#%patch0 -p0
#%patch1 -p0
%patch2 -p1

# 1.4.5 don't have MANIFEST.MF!!!
#mkdir -p src/main/resources/META-INF/
#cp %{SOURCE5} src/main/resources/META-INF/MANIFEST.MF

%{__cp} %{SOURCE1} settings.xml

find . -name "*.jar" -exec rm -f {} \;
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        -DaltDeploymentRepository=jboss-releases::default::file:maven2-brew \
        package javadoc:aggregate deploy:deploy
%endif

%install
%{__rm} -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

# create an empty MANIFEST.MF
cat > MANIFEST.MF << EOT

EOT

%if %without mead
%if 0
# Can be disabled as we no longer sign/unsign JARs
# update & correct the MANIFEST.MF in jar to have a blank end line
# this fix JBPAPP-9191, empty MANIFEST.MF in signed jars
%{jar} ufm xmlschema-core/target/xmlschema-core-%{namedversion}.jar MANIFEST.MF
%endif

%{__cp} -p xmlschema-core/target/xmlschema-core-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/xmlschema-core-%{namedversion}.jar
%{jar} -cf $RPM_BUILD_ROOT%{_javadir}/xmlschema-core-%{namedversion}-sources.jar -C xmlschema-core/src/main/java/ .
%else
%if 0
# Can be disabled as we no longer sign/unsign JARs
# update & correct the MANIFEST.MF in jar to have a blank end line
# this fix JBPAPP-9191, empty MANIFEST.MF in signed jars
%{jar} ufm %{_sourcedir}/xmlschema-core-%{namedversion}.jar MANIFEST.MF
%endif

%{__cp} -p %{_sourcedir}/xmlschema-core-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/xmlschema-core-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/xmlschema-core-%{namedversion}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/xmlschema-core-%{namedversion}-sources.jar
%endif

%add_to_maven_depmap org.apache.ws.xmlschema xmlschema %{namedversion} JPP xmlschema
%add_to_maven_depmap org.apache.ws.xmlschema xmlschema-core %{namedversion} JPP xmlschema-core

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
ln -sf xmlschema-core-%{namedversion}.jar xmlschema-core.jar
)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%if %without mead
%{__cp} -p pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-xmlschema.pom

%{__cp} -p xmlschema-core/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-xmlschema-core.pom
%else
%{__cp} -p %{_sourcedir}/xmlschema-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-xmlschema.pom
%{__cp} -p %{_sourcedir}/xmlschema-core-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-xmlschema-core.pom
%endif

%if %without mead
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-core-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-core-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{short_name}-core-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{short_name}-core-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{short_name}-core-%{namedversion}/META-INF
%endif

%{__ln_s} %{short_name}-core-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-core # ghost symlink
%{__ln_s} %{short_name}-core-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%endif

%if %with repolib

%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%{__rm} -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/apache/ws/xmlschema/xmlschema-core/2.0.2-redhat-2/xmlschema-core-2.0.2-redhat-2.pom*
%{__rm} -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/apache/ws/xmlschema/xmlschema-core/2.0.2-redhat-2/xmlschema-core-2.0.2-redhat-2.jar*
mvn-jpp -e \
    -Dmaven.repo.local=`pwd`/.m2/repository \
    deploy:deploy-file \
    -DpomFile=$RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-xmlschema-core.pom \
    -Dfile=$RPM_BUILD_ROOT%{_javadir}/xmlschema-core-%{namedversion}.jar \
    -Durl=file://%{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/ \

%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap 

%files
%defattr(0644,root,root,0755)
%{_javadir}*/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%if %without mead
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{short_name}-core-%{namedversion}
%{_javadocdir}/%{short_name}-core
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Oct 16 2013 Lin Gao <lgao@redhat.com> - 0:2.0.2-8.redhat_3
- Rebuild to use inner git repository for CC
- Rebuild to use new version/release mechnism
- Regenerate the spec template file
- Move patch to git.app

* Thu Sep 20 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.2-7.redhat_2
- Remove fix for JBPAPP-9190 as it is no longer needed and changes the MD5

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.2-6.redhat_2
- Rebuild for RHEL-5

* Thu Sep 06 2012 David Walluck <dwalluck@redhat.com> 0:2.0.2-5
- fix repolib file ownership
- BuildRequires: java-devel even in MEAD mode
- fix License
- fix Release

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.2-4.redhat_2.1.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.2-4.redhat_1.1.1
- Rebuild using cache signing

* Mon Jul 16 2012 Yong Yang <yyang@redhat.com> - 0:2.0.2-4.redhat_1
- Add Requires
- Add package-name javadoc links

* Wed Jul 04 2012 Yong Yang <yyang@redhat.com> - 0:2.0.2-3.redhat_1
- First mead build
- Install javadoc to xmlschema-core

* Thu May 31 2012 Yong Yang <yyang@redhat.com> 0:2.0.2-2.redhat_1
- Fix JBPAPP-9191, blank manifest in EAP build

* Fri May 04 2012 Yong Yang <yyang@redhat.com> 0:2.0.2-1.redhat_1
- Upgrade to 2.0.2

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0-2_redhat_1.1.1
- Rebuild using cache signing

* Tue Feb 07 2012 Fernando Nasser <fnasser@redhat.com> 0:2.0-2_redhat_1.1
- Use Stax from JDK  ( > 6 )

* Fri Dec 02 2011 Yong Yang <yiwang@redhat.com> 0:2.0-2_redhat_1
- Build for Werewolf

* Mon Jun 20 2011 Yong Yang <yiwang@redhat.com> 0:2.0-1
- Upgrade to 2.0

* Mon Jan 10 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.4.5-2.4
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin
- Add the line to find and remove any binaries

* Mon Jun 28 2010 Permaine Cheung <pcheung@redhat.com> 0:1.4.5-2.3
- BR and R codehaus-stax11-api instead of geronimo-qname

* Mon Jan 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.4.5-2.2.1
- Disable aot compiler


* Thu Dec 10 2009 Martha Benitez <mbenitez@redhat.com> 0:1.4.5-2.2
- Fix repolib location
- Add pom.xml to repolib
- Add sources jar file to main package and repolib
- Fix component id and artifact id in component-info.xml

* Thu Aug 06 2009 Yong Yang <yyang@redhat.com> 0:1.4.5-2.1
- Change jpackage-utils >= 0:1.7.5 to jpackage-utils >= 0:1.7.3
- Comment ws-commons-java5

* Thu Aug 06 2009 Yong Yang <yyang@redhat.com> 0:1.4.5-2
- Add repolib

* Wed Jul 29 2009 Yong Yang <yyang@redhat.com> 0:1.4.5-1
- 1.4.5
- add pom patch and MANIFEST.MF

* Fri Mar 27 2009 Ralph Apel <r.apel at r-apel.de> 0:1.4.2-1.jpp5
- Upgrade to 1.4.2

* Mon Feb 09 2009 Ralph Apel <r.apel at r-apel.de> 0:1.3.2-1.jpp5
- Upgrade to 1.3.2

* Wed May 23 2007 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-1jpp
- Upgrade to 1.3.1
- Fix metadata
- Switch to m2 for build
- Add -javadoc subpackage
- Add gjc_support option
- Optionally build with straight ant and then run different tests
- Make Vendor, Distribution based on macro

* Mon May 29 2006 Fernando Nasser <fnasser@redhat.com> 0:1.0.2-2jpp
- Add missing header

* Thu May 25 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0.2-1jpp
- Upgrade to v1.02

* Mon Jan 30 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0-0.20060119.1jpp
- Initial build.

